#========================================================================================
# package      DE_EPAGES::DHLIntraship::t::unit::ShippingLabelRequest_Origin
# state        public
#----------------------------------------------------------------------------------------
# description  Unit test for Origin module.
#========================================================================================
package DE_EPAGES::DHLIntraship::t::unit::ShippingLabelRequest_Origin;
use base DE_EPAGES::Test::API::UnitTest::Test;

use DE_EPAGES::DHLIntraship::API::REST::ShippingLabelRequest::Origin;

use DE_EPAGES::Test::Mock::Mockify;
use DE_EPAGES::Test::Mock::MockifyEpagesObject;
use Test::More;

use strict;

use constant TEST_ADDRESS_COUNTRY_CODE3 => 'DEU';
use constant TEST_ADDRESS_COUNTRY_NAME_TOO_LONG => 'country name that exceeds the maximum characters limit';
use constant TEST_ADDRESS_COUNTRY_ISO_CODE => 'DE';
use constant TEST_ADDRESS_STATE => '';


#========================================================================================
sub test {
    my $self = shift;

    $self->origin_assemble_positive_test();

    done_testing();
}

#========================================================================================
# Test methods
#========================================================================================
sub origin_assemble_positive_test {
    my $self = shift;
    my $SubTestName = ( caller(0) )[3];

    my $mockedAddress = $self->_createAddress();
    my $hOrigin = DE_EPAGES::DHLIntraship::API::REST::ShippingLabelRequest::Origin->assemble($mockedAddress);

    is_deeply($hOrigin,
        {
          'country' => TEST_ADDRESS_COUNTRY_CODE3,
          'countryISOCode' => TEST_ADDRESS_COUNTRY_ISO_CODE,
          'state' => TEST_ADDRESS_STATE,
        },
        "$SubTestName - Origin hash assembled"
    );
}

#========================================================================================
# Mocking methods
#========================================================================================
sub _createAddress {
    my $self = shift;
    my ($hAddress) = @_;

    my $hParameterList = {
        'Country' => $hAddress->{'Country'} //
            { 'Code3' => TEST_ADDRESS_COUNTRY_CODE3, 'Code2' => TEST_ADDRESS_COUNTRY_ISO_CODE },
        'State' => $hAddress->{'State'} // TEST_ADDRESS_STATE,
    };

    my $MockAddress = DE_EPAGES::Test::Mock::MockifyEpagesObject->new(
            'DE_EPAGES::Address::API::Object::Address',
            $hParameterList
    );

    return $MockAddress->getMockObject();
}

__PACKAGE__->runScript;
